/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2007 hiyohiyo, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCpuid.h"
#include "CpuidInfoDlg.h"

#include "GetFileVersion.h"

#ifdef RUN_TIME_DYNAMIC_LINKING 
#include "../OpenLibSys/OlsApiInitExt.h"
#else // for Load-Time Dynamic Linking
#include "../OpenLibSys/OlsApi.h"
#endif

IMPLEMENT_DYNCREATE(CCpuidInfoDlg, CDHtmlDialog)

CCpuidInfoDlg::CCpuidInfoDlg(CWnd* pParent /*=NULL*/)
	: CDHtmlDialogEx(CCpuidInfoDlg::IDD, NULL/*CCpuidInfoDlg::IDH*/, pParent)
{
	m_Count = 0;
}

CCpuidInfoDlg::~CCpuidInfoDlg()
{
}

void CCpuidInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDHtmlDialogEx::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_CPUID_LIST, m_CpuidList);
}

BOOL CCpuidInfoDlg::OnInitDialog()
{
	CDHtmlDialogEx::OnInitDialog();

// Init List View
	LVCOLUMN myColumn;
	myColumn.mask = LVCF_TEXT | LVCF_WIDTH | LVCF_ORDER ;
// Get Cntrol Width
	CRect cr;
	m_CpuidList.GetClientRect(&cr);
	DWORD width = cr.Width() - GetSystemMetrics(SM_CXVSCROLL);

// Version Check "comctl32.dll"
	double comctl32 = GetFileVersion(_T("comctl32.dll"));
	if(comctl32 >= 470)
	{
		long dwStyle = ListView_GetExtendedListViewStyle(m_CpuidList.m_hWnd);
		dwStyle |=	LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
		ListView_SetExtendedListViewStyle(m_CpuidList.m_hWnd, dwStyle);
	}
	if(comctl32 >= 471)
	{
		m_CpuidList.GetHeaderCtrl()->EnableWindow(FALSE);
	}

	while(m_CpuidList.DeleteColumn(0)){}
	m_CpuidList.DeleteAllItems();
	m_CpuidList.InsertColumn(0, _T("index"), LVCFMT_CENTER, width / 5,0);
	m_CpuidList.InsertColumn(1, _T("EAX"), LVCFMT_LEFT, width / 5,0);
	m_CpuidList.InsertColumn(2, _T("EBX"), LVCFMT_LEFT, width / 5,0);
	m_CpuidList.InsertColumn(3, _T("ECX"), LVCFMT_LEFT, width / 5,0);
	m_CpuidList.InsertColumn(4, _T("EDX"), LVCFMT_LEFT, width / 5,0);

	LVITEM myItem;
	memset(&myItem, 0, sizeof(LVITEM));
	myItem.mask = LVIF_TEXT;

	CString cstr;
	DWORD i = 0;
	DWORD eax, ebx, ecx, edx;

	Cpuid(i, &eax, &ebx, &ecx, &edx);
	InsertCpuidInfo(i, eax, ebx, ecx, edx);

// Standard
	DWORD MaxCpuid = eax;
	for(i = 1; i <= MaxCpuid; i++)
	{
		Cpuid(i, &eax, &ebx, &ecx, &edx);
		InsertCpuidInfo(i, eax, ebx, ecx, edx);
	}

// Extended
	Cpuid(0x80000000, &eax, &ebx, &ecx, &edx);
	if(eax > 0x80000000)
	{
		DWORD MaxCpuidEx = eax;
		for(i = 0x80000000; i <= MaxCpuidEx; i++)
		{
			Cpuid(i, &eax, &ebx, &ecx, &edx);
			InsertCpuidInfo(i, eax, ebx, ecx, edx);
		}
	}

// Transmeta
	Cpuid(0x80860000, &eax, &ebx, &ecx, &edx);
	if(eax > 0x80860000)
	{
		DWORD MaxCpuidTx = eax;
		for(i = 0x80860000; i <= MaxCpuidTx; i++)
		{
			Cpuid(i, &eax, &ebx, &ecx, &edx);
			InsertCpuidInfo(i, eax, ebx, ecx, edx);
		}
	}

// VIA
	Cpuid(0xC0000000, &eax, &ebx, &ecx, &edx);
	if(eax > 0xC0000000)
	{
		DWORD MaxCpuidCx = eax;
		for(i = 0xC0000000; i <= MaxCpuidCx; i++)
		{
			Cpuid(i, &eax, &ebx, &ecx, &edx);
			InsertCpuidInfo(i, eax, ebx, ecx, edx);
		}
	}

	InitDHtmlDialog(cr.Width() + 25, cr.Height() + 25, 
		((CCrystalCpuidApp*)AfxGetApp())->m_CpuidInfoDlgPath);

	return TRUE;
}

void CCpuidInfoDlg::InsertCpuidInfo(DWORD index, DWORD eax, DWORD ebx, DWORD ecx, DWORD edx)
{
	CString cstr;
	cstr.Format(_T("%08Xh"), index);	m_CpuidList.InsertItem(m_Count, cstr);
	cstr.Format(_T("%08Xh"), eax);		m_CpuidList.SetItemText(m_Count, 1, cstr);
	cstr.Format(_T("%08Xh"), ebx);		m_CpuidList.SetItemText(m_Count, 2, cstr);
	cstr.Format(_T("%08Xh"), ecx);		m_CpuidList.SetItemText(m_Count, 3, cstr);
	cstr.Format(_T("%08Xh"), edx);		m_CpuidList.SetItemText(m_Count, 4, cstr);
	m_Count++;
}

BEGIN_MESSAGE_MAP(CCpuidInfoDlg, CDHtmlDialogEx)
END_MESSAGE_MAP()

BEGIN_DHTML_EVENT_MAP(CCpuidInfoDlg)
END_DHTML_EVENT_MAP()
