// CrystalCpuidDlg.h : header file
//

#pragma once

#include "WmiInfo.h"

#include "AboutDlg.h"
#include "FeatureFlagsDlg.h"
#include "BiosInfoDlg.h"
#include "CpuidInfoDlg.h"
#include "SystemInfoDlg.h"


#define WM_THEME_ID			(WM_USER+0x100)
#define WM_LANGUAGE_ID		(WM_USER+0x200)
#define MAIN_CSS_FILE_NAME	_T("Main.css")

// CCrystalCpuidDlg dialog
class CCrystalCpuidDlg : public CDHtmlDialogEx
{
// Construction
public:
	CCrystalCpuidDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_CRYSTALCPUID_DIALOG };

	static const int SIZE_X = 480;
	static const int SIZE_Y = 360;

	TCHAR m_Ini[MAX_PATH];
	CString m_CurrentLocalID;

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;

	void InitMenu();
	void InitThemeLang();
	void ChangeTheme(CString ThemeName);
	void ChangeLang(CString LangName);

	CStringArray m_MenuArrayTheme;
	CStringArray m_MenuArrayLang;
	CString m_CurrentTheme;
	CString m_CurrentLang;

	CWmiInfo* m_WmiInfo;

	CBiosInfoDlg*			m_BiosInfoDlg;
	CFeatureFlagsDlg*		m_FeatureFlagsDlg;
	CAboutDlg*				m_AboutDlg;
	CCpuidInfoDlg*			m_CpuidInfoDlg;
	CSystemInfoDlg*			m_SystemInfoDlg;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual void OnDocumentComplete(LPDISPATCH pDisp, LPCTSTR szUrl);

	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
	DECLARE_DHTML_EVENT_MAP()
public:
	afx_msg void OnAbout();
	afx_msg void OnFeatureFlags();
	afx_msg void OnBiosInfo();
	afx_msg void OnCpuidInfo();
	afx_msg void OnExit();
	afx_msg void OnSystemInfo();
};
