/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2007 hiyohiyo, All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "CrystalCpuid.h"
#include "FeatureFlagsDlg.h"

#ifdef RUN_TIME_DYNAMIC_LINKING 
#include "../OpenLibSys/OlsApiInitExt.h"
#else // for Load-Time Dynamic Linking
#include "../OpenLibSys/OlsApi.h"
#endif

IMPLEMENT_DYNCREATE(CFeatureFlagsDlg, CDHtmlDialog)

CFeatureFlagsDlg::CFeatureFlagsDlg(CWnd* pParent /*=NULL*/)
	: CDHtmlDialogEx(CFeatureFlagsDlg::IDD, NULL, pParent)
{
	m_FullName.SetSize(32);
	m_ShortName.SetSize(32);
	m_Flag.SetSize(32);
}

CFeatureFlagsDlg::~CFeatureFlagsDlg()
{
}

void CFeatureFlagsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDHtmlDialogEx::DoDataExchange(pDX);

	CString cstr;
	for(int i = 0; i < 32; i++)
	{
		cstr.Format(_T("%02d"), i); 
		DDX_DHtml_ElementText(pDX, _T("FullName") + cstr, DISPID_IHTMLELEMENT_INNERTEXT, m_FullName[i]);
		DDX_DHtml_ElementText(pDX, _T("ShortName") + cstr, DISPID_IHTMLELEMENT_INNERTEXT, m_ShortName[i]);
		DDX_DHtml_ElementText(pDX, _T("Flag") + cstr, DISPID_IHTMLELEMENT_INNERTEXT, m_Flag[i]);
	}
}

BOOL CFeatureFlagsDlg::OnInitDialog()
{
	CDHtmlDialogEx::OnInitDialog();

	InitDHtmlDialog(SIZE_X, SIZE_Y, 
		((CCrystalCpuidApp*)AfxGetApp())->m_FeatureFlagsDlgPath);

	return TRUE;
}

void CFeatureFlagsDlg::OnDocumentComplete(LPDISPATCH pDisp, LPCTSTR szUrl)
{
	CString cstr;
	cstr = szUrl;
	if(cstr.Find(_T("html")) != -1 || cstr.Find(_T("dlg")) != -1)
	{
		OnFeatureFlagStdEdx(NULL);
	}

	CDHtmlDialogEx::OnDocumentComplete(pDisp, szUrl);
}

BEGIN_MESSAGE_MAP(CFeatureFlagsDlg, CDHtmlDialogEx)
END_MESSAGE_MAP()

BEGIN_DHTML_EVENT_MAP(CFeatureFlagsDlg)
	DHTML_EVENT_ONCLICK(_T("FeatureFlagStdEdx"), OnFeatureFlagStdEdx)
	DHTML_EVENT_ONCLICK(_T("FeatureFlagStdEcx"), OnFeatureFlagStdEcx)
	DHTML_EVENT_ONCLICK(_T("FeatureFlagExEdx"), OnFeatureFlagExEdx)
	DHTML_EVENT_ONCLICK(_T("FeatureFlagExEcx"), OnFeatureFlagExEcx)
	DHTML_EVENT_ONCLICK(_T("FeatureFlagVia"), OnFeatureFlagVia)
	DHTML_EVENT_ONCLICK(_T("FeatureFlagTransmeta"), OnFeatureFlagTransmeta)
	DHTML_EVENT_ONCLICK(_T("FeatureFlagPowerManagement"), OnFeatureFlagPowerManagement)
END_DHTML_EVENT_MAP()

HRESULT CFeatureFlagsDlg::OnFeatureFlagStdEdx(IHTMLElement* /*pElement*/)
{
	DWORD eax, ebx, ecx, edx;

	Cpuid(0x1, &eax, &ebx, &ecx, &edx);
	DWORD value = edx;

	m_ShortName[ 0] = _T("FPU");
	m_ShortName[ 1] = _T("VME");
	m_ShortName[ 2] = _T("DE");
	m_ShortName[ 3] = _T("PSE");
	m_ShortName[ 4] = _T("TSC");
	m_ShortName[ 5] = _T("MSR");
	m_ShortName[ 6] = _T("PAE");
	m_ShortName[ 7] = _T("MCE");
	m_ShortName[ 8] = _T("CX8");
	m_ShortName[ 9] = _T("APIC");
	m_ShortName[10] = _T("");
	m_ShortName[11] = _T("SEP");
	m_ShortName[12] = _T("MTRR");
	m_ShortName[13] = _T("PGE");
	m_ShortName[14] = _T("MCA");
	m_ShortName[15] = _T("CMOV");
	m_ShortName[16] = _T("PAT");
	m_ShortName[17] = _T("PSE-36");
	m_ShortName[18] = _T("PSN");
	m_ShortName[19] = _T("CLFSH");
	m_ShortName[20] = _T("");
	m_ShortName[21] = _T("DS");
	m_ShortName[22] = _T("ACPI");
	m_ShortName[23] = _T("MMX");
	m_ShortName[24] = _T("FXSR");
	m_ShortName[25] = _T("SSE");
	m_ShortName[26] = _T("SSE2");
	m_ShortName[27] = _T("SS");
	m_ShortName[28] = _T("HTT");
	m_ShortName[29] = _T("TM");
	m_ShortName[30] = _T("IA-64");
	m_ShortName[31] = _T("PBE");

	m_FullName[ 0] = _T("Floating-Point Unit");
	m_FullName[ 1] = _T("Virtual Mode Extensions");
	m_FullName[ 2] = _T("Debugging Extensions");
	m_FullName[ 3] = _T("Page Size Extensions");
	m_FullName[ 4] = _T("Time Stamp Counter");
	m_FullName[ 5] = _T("Model Specific Registers");
	m_FullName[ 6] = _T("Page Address Extensions");
	m_FullName[ 7] = _T("Machine Check Exception");
	m_FullName[ 8] = _T("CMPXCHG8B Instruction");
	m_FullName[ 9] = _T("APIC");
	m_FullName[10] = _T("Reserved");
	m_FullName[11] = _T("SYSENTER/SYSEXIT Instructions");
	m_FullName[12] = _T("Memory Type Range Registers");
	m_FullName[13] = _T("Global Paging Extension");
	m_FullName[14] = _T("Machine Check Architecture");
	m_FullName[15] = _T("Conditional Move Instructions");

	m_FullName[16] = _T("Page Attribute Table");
	m_FullName[17] = _T("36-bit Page Size Extension");
	m_FullName[18] = _T("Processor Serial Number");
	m_FullName[19] = _T("CLFLUSH Instruction");
	m_FullName[20] = _T("Reserved");
	m_FullName[21] = _T("Debug Store");
	m_FullName[22] = _T("ACPI");
	m_FullName[23] = _T("MMX Instructions");
	m_FullName[24] = _T("FXSAVE/FXRSTOR Instructions");
	m_FullName[25] = _T("Streaming SIMD Extensions");
	m_FullName[26] = _T("Streaming SIMD Extensions 2");
	m_FullName[27] = _T("Self-Snoop");
	m_FullName[28] = _T("Hyper-Threading Technology");
	m_FullName[29] = _T("Thermal Monitor");
	m_FullName[30] = _T("IA-64 Processor Capable");
	m_FullName[31] = _T("Pending Break Enable");

	for(int i = 0; i < 32; i++)
	{
		if(value & (1 << i))
		{
			m_Flag[i] = _T("YES");
		}
		else
		{
			m_Flag[i] = _T("NO");
		}
	}

	UpdateData(FALSE);

	return S_FALSE;
}

HRESULT CFeatureFlagsDlg::OnFeatureFlagStdEcx(IHTMLElement* /*pElement*/)
{
	DWORD eax, ebx, ecx, edx;

	Cpuid(0x1, &eax, &ebx, &ecx, &edx);
	DWORD value = ecx;

	m_ShortName[ 0] = _T("SSE3");
	m_ShortName[ 1] = _T("");
	m_ShortName[ 2] = _T("");
	m_ShortName[ 3] = _T("MONITOR");
	m_ShortName[ 4] = _T("DS-CPL");
	m_ShortName[ 5] = _T("VMX");
	m_ShortName[ 6] = _T("SMX");
	m_ShortName[ 7] = _T("EST");
	m_ShortName[ 8] = _T("TM2");
	m_ShortName[ 9] = _T("SSSE3");
	m_ShortName[10] = _T("CID");
	m_ShortName[11] = _T("");
	m_ShortName[12] = _T("");
	m_ShortName[13] = _T("CX16");
	m_ShortName[14] = _T("xTPR");
	m_ShortName[15] = _T("PDCM");
	m_ShortName[16] = _T("");
	m_ShortName[17] = _T("");
	m_ShortName[18] = _T("DCA");
	m_ShortName[19] = _T("SSE4.1");
	m_ShortName[20] = _T("SSE4.2");
	m_ShortName[21] = _T("x2APIC");
	m_ShortName[22] = _T("");
	m_ShortName[23] = _T("POPCNT");
	m_ShortName[24] = _T("");
	m_ShortName[25] = _T("");
	m_ShortName[26] = _T("");
	m_ShortName[27] = _T("");
	m_ShortName[28] = _T("");
	m_ShortName[29] = _T("");
	m_ShortName[30] = _T("");
	m_ShortName[31] = _T("");

	m_FullName[ 0] = _T("Streaming SIMD Extensions 3");
	m_FullName[ 1] = _T("Reserved");
	m_FullName[ 2] = _T("Reserved");
	m_FullName[ 3] = _T("MONITOR/MWAIT Instructions");
	m_FullName[ 4] = _T("CPL Qualified Debug Store");
	m_FullName[ 5] = _T("Virtual Machine Extentions");
	m_FullName[ 6] = _T("Reserved");
	m_FullName[ 7] = _T("Enhanced SpeedStep Technology");
	m_FullName[ 8] = _T("Thermal Monitor 2");
	m_FullName[ 9] = _T("Supplemental SSE3");
	m_FullName[10] = _T("Context ID");
	m_FullName[11] = _T("Reserved");
	m_FullName[12] = _T("Reserved");
	m_FullName[13] = _T("CMPXCHG16B");
	m_FullName[14] = _T("Send Task Priority Messages");
	m_FullName[15] = _T("Perf/Debug Capability MSR");
                         
	m_FullName[16] = _T("Reserved");
	m_FullName[17] = _T("Reserved");
	m_FullName[18] = _T("Direct Cache Access");
	m_FullName[19] = _T("Streaming SIMD Extensions 4.1");
	m_FullName[20] = _T("Streaming SIMD Extensions 4.2");
	m_FullName[21] = _T("x2APIC");
	m_FullName[22] = _T("Reserved");
	m_FullName[23] = _T("Population Count Instruction");
	m_FullName[24] = _T("Reserved");
	m_FullName[25] = _T("Reserved");
	m_FullName[26] = _T("Reserved");
	m_FullName[27] = _T("Reserved");
	m_FullName[28] = _T("Reserved");
	m_FullName[29] = _T("Reserved");
	m_FullName[30] = _T("Reserved");
	m_FullName[31] = _T("Reserved");

	for(int i = 0; i < 32; i++)
	{
		if(value & (1 << i))
		{
			m_Flag[i] = _T("YES");
		}
		else
		{
			m_Flag[i] = _T("NO");
		}
	}

	UpdateData(FALSE);

	return S_FALSE;
}

HRESULT CFeatureFlagsDlg::OnFeatureFlagExEdx(IHTMLElement* /*pElement*/)
{
	DWORD eax, ebx, ecx, edx;
	DWORD value = 0;

	Cpuid(0x80000000, &eax, &ebx, &ecx, &edx);
	if(eax >= 0x80000001)
	{
		Cpuid(0x80000001, &eax, &ebx, &ecx, &edx);
		value = edx;
	}

	m_ShortName[ 0] = _T("FPU");
	m_ShortName[ 1] = _T("VME");
	m_ShortName[ 2] = _T("DE");
	m_ShortName[ 3] = _T("PSE");
	m_ShortName[ 4] = _T("TSC");
	m_ShortName[ 5] = _T("MSR");
	m_ShortName[ 6] = _T("PAE");
	m_ShortName[ 7] = _T("MCE");
	m_ShortName[ 8] = _T("CX8");
	m_ShortName[ 9] = _T("APIC");
	m_ShortName[10] = _T("");
	m_ShortName[11] = _T("SEP");
	m_ShortName[12] = _T("MTRR");
	m_ShortName[13] = _T("PGE");
	m_ShortName[14] = _T("MCA");
	m_ShortName[15] = _T("CMOV");
	m_ShortName[16] = _T("PAT");
	m_ShortName[17] = _T("PSE-36");
	m_ShortName[18] = _T("");
	m_ShortName[19] = _T("MP");
	m_ShortName[20] = _T("NX/XD");
	m_ShortName[21] = _T("");
	m_ShortName[22] = _T("MMX+");
	m_ShortName[23] = _T("MMX");
	m_ShortName[24] = _T("FXSR");
	m_ShortName[25] = _T("FFXSR");
	m_ShortName[26] = _T("P1GB");
	m_ShortName[27] = _T("RDTSCP");
	m_ShortName[28] = _T("");
	m_ShortName[29] = _T("x64");
	m_ShortName[30] = _T("3DNow!+");
	m_ShortName[31] = _T("3DNow!");

	m_FullName[ 0] = _T("Floating-Point Unit");
	m_FullName[ 1] = _T("Virtual Mode Extensions");
	m_FullName[ 2] = _T("Debugging Extensions");
	m_FullName[ 3] = _T("Page Size Extensions");
	m_FullName[ 4] = _T("Time Stamp Counter");
	m_FullName[ 5] = _T("Model Specific Registers");
	m_FullName[ 6] = _T("Page Address Extensions");
	m_FullName[ 7] = _T("Machine Check Exception");
	m_FullName[ 8] = _T("CMPXCHG8B Instruction");
	m_FullName[ 9] = _T("On-chip APIC Hardware");
	m_FullName[10] = _T("Reserved");
	m_FullName[11] = _T("SYSCALL/SYSRET Instructions");
	m_FullName[12] = _T("Memory Type Range Registers");
	m_FullName[13] = _T("Page Global Enable");
	m_FullName[14] = _T("Machine Check Architecture");
	m_FullName[15] = _T("Conditional Move Instruction");
	m_FullName[16] = _T("Page Attribute Table");
	m_FullName[17] = _T("36-bit Page Size Extension");
	m_FullName[18] = _T("Reserved");
	m_FullName[19] = _T("Multiprocessing Capable");
	m_FullName[20] = _T("No Execute/Execute Disable");
	m_FullName[21] = _T("Reserved");
	m_FullName[22] = _T("MMX Instruction Extensions");
	m_FullName[23] = _T("MMX Instructions");
	m_FullName[24] = _T("FXSAVE/FXRSTOR Instructions");
	m_FullName[25] = _T("FXSAVE/FXRSTOR optimizations");
	m_FullName[26] = _T("1GB Page Size");
	m_FullName[27] = _T("RDTSCP instructions");
	m_FullName[28] = _T("Reserved");
	m_FullName[29] = _T("AMD64/Intel 64");
	m_FullName[30] = _T("3DNow! Instruction Extensions");
	m_FullName[31] = _T("3DNow! Instructions");

	for(int i = 0; i < 32; i++)
	{
		if(value & (1 << i))
		{
			m_Flag[i] = _T("YES");
		}
		else
		{
			m_Flag[i] = _T("NO");
		}
	}

	UpdateData(FALSE);

	return S_FALSE;
}

HRESULT CFeatureFlagsDlg::OnFeatureFlagExEcx(IHTMLElement* /*pElement*/)
{
	DWORD eax, ebx, ecx, edx;
	DWORD value = 0;

	Cpuid(0x80000000, &eax, &ebx, &ecx, &edx);
	if(eax >= 0x80000001)
	{
		Cpuid(0x80000001, &eax, &ebx, &ecx, &edx);
		value = ecx;
	}

	m_ShortName[ 0] = _T("LAHF");
	m_ShortName[ 1] = _T("CMPL");
	m_ShortName[ 2] = _T("AMD-V");
	m_ShortName[ 3] = _T("EAS");
	m_ShortName[ 4] = _T("AMC8");
	m_ShortName[ 5] = _T("ABM");
	m_ShortName[ 6] = _T("SSE4A");
	m_ShortName[ 7] = _T("MASSE");
	m_ShortName[ 8] = _T("PREFETCH");
	m_ShortName[ 9] = _T("OSVW");
	m_ShortName[10] = _T("IBS");
	m_ShortName[11] = _T("");
	m_ShortName[12] = _T("SKINIT");
	m_ShortName[13] = _T("WDT");
	m_ShortName[14] = _T("");
	m_ShortName[15] = _T("");
	m_ShortName[16] = _T("");
	m_ShortName[17] = _T("");
	m_ShortName[18] = _T("");
	m_ShortName[19] = _T("");
	m_ShortName[20] = _T("");
	m_ShortName[21] = _T("");
	m_ShortName[22] = _T("");
	m_ShortName[23] = _T("");
	m_ShortName[24] = _T("");
	m_ShortName[25] = _T("");
	m_ShortName[26] = _T("");
	m_ShortName[27] = _T("");
	m_ShortName[28] = _T("");
	m_ShortName[29] = _T("");
	m_ShortName[30] = _T("");
	m_ShortName[31] = _T("");

	m_FullName[ 0] = _T("LAHF/SAHF Support");
	m_FullName[ 1] = _T("Core MultiProcessing legacy");
	m_FullName[ 2] = _T("SVM : Secure virtual machine");
	m_FullName[ 3] = _T("Extended APIC");
	m_FullName[ 4] = _T("LOCK MOV CR0 means MOV CR8");
	m_FullName[ 5] = _T("Advanced Bit Manipulation");
	m_FullName[ 6] = _T("Streaming SIMD Extensions 4 AMD");
	m_FullName[ 7] = _T("Misaligned SSE Modus");
	m_FullName[ 8] = _T("3DNow! Prefetch");
	m_FullName[ 9] = _T("OS Visible Workaround");
	m_FullName[10] = _T("Instruction Based Sampling");
	m_FullName[11] = _T("Reserved");
	m_FullName[12] = _T("SKINIT/STGI/DEV Support");
	m_FullName[13] = _T("Watchdog timer");
	m_FullName[14] = _T("Reserved");
	m_FullName[15] = _T("Reserved");
	m_FullName[16] = _T("Reserved");
	m_FullName[17] = _T("Reserved");
	m_FullName[18] = _T("Reserved");
	m_FullName[19] = _T("Reserved");
	m_FullName[20] = _T("Reserved");
	m_FullName[21] = _T("Reserved");
	m_FullName[22] = _T("Reserved");
	m_FullName[23] = _T("Reserved");
	m_FullName[24] = _T("Reserved");
	m_FullName[25] = _T("Reserved");
	m_FullName[26] = _T("Reserved");
	m_FullName[27] = _T("Reserved");
	m_FullName[28] = _T("Reserved");
	m_FullName[29] = _T("Reserved");
	m_FullName[30] = _T("Reserved");
	m_FullName[31] = _T("Reserved");

	for(int i = 0; i < 32; i++)
	{
		if(value & (1 << i))
		{
			m_Flag[i] = _T("YES");
		}
		else
		{
			m_Flag[i] = _T("NO");
		}
	}

	UpdateData(FALSE);

	return S_FALSE;
}

HRESULT CFeatureFlagsDlg::OnFeatureFlagVia(IHTMLElement* /*pElement*/)
{
	DWORD eax, ebx, ecx, edx;
	DWORD value = 0;

	Cpuid(0x80860000, &eax, &ebx, &ecx, &edx);
	if(eax >= 0x80860001)
	{
		Cpuid(0x80860001, &eax, &ebx, &ecx, &edx);
		value = edx;
	}

	m_ShortName[ 0] = _T("AIS");
	m_ShortName[ 1] = _T("AIS-E");
	m_ShortName[ 2] = _T("RNG");
	m_ShortName[ 3] = _T("RNG-E");
	m_ShortName[ 4] = _T("LH");
	m_ShortName[ 5] = _T("FEMMS");
	m_ShortName[ 6] = _T("ACE");
	m_ShortName[ 7] = _T("ACE-E");
	m_ShortName[ 8] = _T("MM");
	m_ShortName[ 9] = _T("MM-E");
	m_ShortName[10] = _T("");
	m_ShortName[11] = _T("");
	m_ShortName[12] = _T("");
	m_ShortName[13] = _T("");
	m_ShortName[14] = _T("");
	m_ShortName[15] = _T("");
	m_ShortName[16] = _T("");
	m_ShortName[17] = _T("");
	m_ShortName[18] = _T("");
	m_ShortName[19] = _T("");
	m_ShortName[20] = _T("");
	m_ShortName[21] = _T("");
	m_ShortName[22] = _T("");
	m_ShortName[23] = _T("");
	m_ShortName[24] = _T("");
	m_ShortName[25] = _T("");
	m_ShortName[26] = _T("");
	m_ShortName[27] = _T("");
	m_ShortName[28] = _T("");
	m_ShortName[29] = _T("");
	m_ShortName[30] = _T("");
	m_ShortName[31] = _T("");

	m_FullName[ 0] = _T("Alternate Instruction Set");
	m_FullName[ 1] = _T("AIS enabled");
	m_FullName[ 2] = _T("Random Number Generator");
	m_FullName[ 3] = _T("RNG enabled");
	m_FullName[ 4] = _T("LongHaul MSR 0000_110Ah");
	m_FullName[ 5] = _T("FEMMS");
	m_FullName[ 6] = _T("Advanced Cryptography Engine");
	m_FullName[ 7] = _T("ACE enabled");
	m_FullName[ 8] = _T("Montgomery Multiplier");
	m_FullName[ 9] = _T("Montgomery Multiplier enabled");
	m_FullName[10] = _T("Reserved");
	m_FullName[11] = _T("Reserved");
	m_FullName[12] = _T("Reserved");
	m_FullName[13] = _T("Reserved");
	m_FullName[14] = _T("Reserved");
	m_FullName[15] = _T("Reserved");
	m_FullName[16] = _T("Reserved");
	m_FullName[17] = _T("Reserved");
	m_FullName[18] = _T("Reserved");
	m_FullName[19] = _T("Reserved");
	m_FullName[20] = _T("Reserved");
	m_FullName[21] = _T("Reserved");
	m_FullName[22] = _T("Reserved");
	m_FullName[23] = _T("Reserved");
	m_FullName[24] = _T("Reserved");
	m_FullName[25] = _T("Reserved");
	m_FullName[26] = _T("Reserved");
	m_FullName[27] = _T("Reserved");
	m_FullName[28] = _T("Reserved");
	m_FullName[29] = _T("Reserved");
	m_FullName[30] = _T("Reserved");
	m_FullName[31] = _T("Reserved");

	for(int i = 0; i < 32; i++)
	{
		if(value & (1 << i))
		{
			m_Flag[i] = _T("YES");
		}
		else
		{
			m_Flag[i] = _T("NO");
		}
	}

	UpdateData(FALSE);

	return S_FALSE;
}

HRESULT CFeatureFlagsDlg::OnFeatureFlagTransmeta(IHTMLElement* /*pElement*/)
{
	DWORD eax, ebx, ecx, edx;
	DWORD value = 0;

	Cpuid(0xC0000000, &eax, &ebx, &ecx, &edx);
	if(eax >= 0xC0000001)
	{
		Cpuid(0xC0000001, &eax, &ebx, &ecx, &edx);
		value = edx;
	}

	m_ShortName[ 0] = _T("BAD");
	m_ShortName[ 1] = _T("LR");
	m_ShortName[ 2] = _T("");
	m_ShortName[ 3] = _T("LRTI");
	m_ShortName[ 4] = _T("");
	m_ShortName[ 5] = _T("");
	m_ShortName[ 6] = _T("");
	m_ShortName[ 7] = _T("");
	m_ShortName[ 8] = _T("");
	m_ShortName[ 9] = _T("");
	m_ShortName[10] = _T("");
	m_ShortName[11] = _T("");
	m_ShortName[12] = _T("");
	m_ShortName[13] = _T("");
	m_ShortName[14] = _T("");
	m_ShortName[15] = _T("");
	m_ShortName[16] = _T("");
	m_ShortName[17] = _T("");
	m_ShortName[18] = _T("");
	m_ShortName[19] = _T("");
	m_ShortName[20] = _T("");
	m_ShortName[21] = _T("");
	m_ShortName[22] = _T("");
	m_ShortName[23] = _T("");
	m_ShortName[24] = _T("");
	m_ShortName[25] = _T("");
	m_ShortName[26] = _T("");
	m_ShortName[27] = _T("");
	m_ShortName[28] = _T("");
	m_ShortName[29] = _T("");
	m_ShortName[30] = _T("");
	m_ShortName[31] = _T("");

	m_FullName[ 0] = _T("recovery CMS active");
	m_FullName[ 1] = _T("LongRun");
	m_FullName[ 2] = _T("Reserved");
	m_FullName[ 3] = _T("LongRun Table Interface");
	m_FullName[ 4] = _T("Reserved");
	m_FullName[ 5] = _T("Reserved");
	m_FullName[ 6] = _T("Reserved");
	m_FullName[ 7] = _T("Reserved");
	m_FullName[ 8] = _T("Reserved");
	m_FullName[ 9] = _T("Reserved");
	m_FullName[10] = _T("Reserved");
	m_FullName[11] = _T("Reserved");
	m_FullName[12] = _T("Reserved");
	m_FullName[13] = _T("Reserved");
	m_FullName[14] = _T("Reserved");
	m_FullName[15] = _T("Reserved");
	m_FullName[16] = _T("Reserved");
	m_FullName[17] = _T("Reserved");
	m_FullName[18] = _T("Reserved");
	m_FullName[19] = _T("Reserved");
	m_FullName[20] = _T("Reserved");
	m_FullName[21] = _T("Reserved");
	m_FullName[22] = _T("Reserved");
	m_FullName[23] = _T("Reserved");
	m_FullName[24] = _T("Reserved");
	m_FullName[25] = _T("Reserved");
	m_FullName[26] = _T("Reserved");
	m_FullName[27] = _T("Reserved");
	m_FullName[28] = _T("Reserved");
	m_FullName[29] = _T("Reserved");
	m_FullName[30] = _T("Reserved");
	m_FullName[31] = _T("Reserved");

	for(int i = 0; i < 32; i++)
	{
		if(value & (1 << i))
		{
			m_Flag[i] = _T("YES");
		}
		else
		{
			m_Flag[i] = _T("NO");
		}
	}

	UpdateData(FALSE);

	return S_FALSE;
}

HRESULT CFeatureFlagsDlg::OnFeatureFlagPowerManagement(IHTMLElement* /*pElement*/)
{
	DWORD eax, ebx, ecx, edx;
	DWORD value = 0;

	Cpuid(0x80000000, &eax, &ebx, &ecx, &edx);
	if(eax >= 0x80000007)
	{
		Cpuid(0x80000007, &eax, &ebx, &ecx, &edx);
		value = edx;
	}

	m_ShortName[ 0] = _T("TS");
	m_ShortName[ 1] = _T("FID");
	m_ShortName[ 2] = _T("VID");
	m_ShortName[ 3] = _T("TTP");
	m_ShortName[ 4] = _T("TM");
	m_ShortName[ 5] = _T("STC");
	m_ShortName[ 6] = _T("MUL");
	m_ShortName[ 7] = _T("HWPS");
	m_ShortName[ 8] = _T("ITSC");
	m_ShortName[ 9] = _T("");
	m_ShortName[10] = _T("");
	m_ShortName[11] = _T("");
	m_ShortName[12] = _T("");
	m_ShortName[13] = _T("");
	m_ShortName[14] = _T("");
	m_ShortName[15] = _T("");
	m_ShortName[16] = _T("");
	m_ShortName[17] = _T("");
	m_ShortName[18] = _T("");
	m_ShortName[19] = _T("");
	m_ShortName[20] = _T("");
	m_ShortName[21] = _T("");
	m_ShortName[22] = _T("");
	m_ShortName[23] = _T("");
	m_ShortName[24] = _T("");
	m_ShortName[25] = _T("");
	m_ShortName[26] = _T("");
	m_ShortName[27] = _T("");
	m_ShortName[28] = _T("");
	m_ShortName[29] = _T("");
	m_ShortName[30] = _T("");
	m_ShortName[31] = _T("");

	m_FullName[ 0] = _T("Temperature Sensor");
	m_FullName[ 1] = _T("Frequency ID Control");
	m_FullName[ 2] = _T("Voltage ID Control");
	m_FullName[ 3] = _T("Thermal Trip");
	m_FullName[ 4] = _T("Thermal Monitoring");
	m_FullName[ 5] = _T("Software Thermanl Control");
	m_FullName[ 6] = _T("100MHz Multiplier Steps");
	m_FullName[ 7] = _T("Hardware P-State Control");
	m_FullName[ 8] = _T("Invariant TSC");
	m_FullName[ 9] = _T("Reserved");
	m_FullName[10] = _T("Reserved");
	m_FullName[11] = _T("Reserved");
	m_FullName[12] = _T("Reserved");
	m_FullName[13] = _T("Reserved");
	m_FullName[14] = _T("Reserved");
	m_FullName[15] = _T("Reserved");
	m_FullName[16] = _T("Reserved");
	m_FullName[17] = _T("Reserved");
	m_FullName[18] = _T("Reserved");
	m_FullName[19] = _T("Reserved");
	m_FullName[20] = _T("Reserved");
	m_FullName[21] = _T("Reserved");
	m_FullName[22] = _T("Reserved");
	m_FullName[23] = _T("Reserved");
	m_FullName[24] = _T("Reserved");
	m_FullName[25] = _T("Reserved");
	m_FullName[26] = _T("Reserved");
	m_FullName[27] = _T("Reserved");
	m_FullName[28] = _T("Reserved");
	m_FullName[29] = _T("Reserved");
	m_FullName[30] = _T("Reserved");
	m_FullName[31] = _T("Reserved");

	for(int i = 0; i < 32; i++)
	{
		if(value & (1 << i))
		{
			m_Flag[i] = _T("YES");
		}
		else
		{
			m_Flag[i] = _T("NO");
		}
	}

	UpdateData(FALSE);

	return S_FALSE;
}